"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.SAGA_LOCATION = exports.TASK_CANCEL = exports.TASK = exports.SELF_CANCELLATION = exports.SAGA_ACTION = exports.MULTICAST = exports.MATCH = exports.IO = exports.CHANNEL_END_TYPE = exports.CHANNEL_END = exports.CANCEL = void 0;

var createName = function createName(name) {
  return "@@redux-saga/" + name;
};

var createSymbol = function createSymbol(id) {
  id = createName(id);
  return typeof Symbol === 'function' ? Symbol(id) : id;
};

var createGlobalSymbol = function createGlobalSymbol(id) {
  id = createName(id);
  return typeof Symbol === 'function' && typeof Symbol.for === 'function' ? Symbol.for(id) : id;
};

var CANCEL =
/*#__PURE__*/
createSymbol('CANCEL_PROMISE');
exports.CANCEL = CANCEL;
var CHANNEL_END =
/*#__PURE__*/
createSymbol('CHANNEL_END');
exports.CHANNEL_END = CHANNEL_END;
var CHANNEL_END_TYPE =
/*#__PURE__*/
createSymbol('CHANNEL_END');
exports.CHANNEL_END_TYPE = CHANNEL_END_TYPE;
var IO =
/*#__PURE__*/
createSymbol('IO');
exports.IO = IO;
var MATCH =
/*#__PURE__*/
createSymbol('MATCH');
exports.MATCH = MATCH;
var MULTICAST =
/*#__PURE__*/
createSymbol('MULTICAST');
exports.MULTICAST = MULTICAST;
var SAGA_ACTION =
/*#__PURE__*/
createSymbol('SAGA_ACTION');
exports.SAGA_ACTION = SAGA_ACTION;
var SELF_CANCELLATION =
/*#__PURE__*/
createSymbol('SELF_CANCELLATION');
exports.SELF_CANCELLATION = SELF_CANCELLATION;
var TASK =
/*#__PURE__*/
createSymbol('TASK');
exports.TASK = TASK;
var TASK_CANCEL =
/*#__PURE__*/
createSymbol('TASK_CANCEL');
exports.TASK_CANCEL = TASK_CANCEL;
var SAGA_LOCATION =
/*#__PURE__*/
createGlobalSymbol('LOCATION');
exports.SAGA_LOCATION = SAGA_LOCATION;